/*    
 * Copyright (C) 1999 Antonio Luque Estepa  <aluque@bart.us.es>
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
import fecha;
import java.lang.Math;
import java.awt.*;
import java.applet.*;


public class easter extends Applet {
    static int anio;
    boolean procesado; //Estamos listos para dar una respuesta?
    public static final String titulo="Easter 1.0";
    public static final String copyright="Easter 1.0  Antonio Luque Estepa <aluque@bart.us.es> 1999";
    
    private static final int JULIAN5OCT1582=577738;
    //Tabla de lunas llenas pascuales dependiendo de la epacta
    //Seguramente habra una forma mejor de hacer esto, pero por ahora yo no la se
    private static fecha[] pascal={
        new fecha(0,0),
	new fecha(0,0),
	new fecha(0,0),
	new fecha(0,0),
	new fecha(0,0),
	new fecha(0,0),
	new fecha(0,0),
	new fecha(0,0),
	new fecha(0,0),
	new fecha(0,0),
	new fecha(0,0),
	new fecha(0,0),
	new fecha(0,0),
	new fecha(0,0),
	new fecha(0,0),
	new fecha(0,0),
	new fecha(0,0),
	new fecha(0,0),
	new fecha(0,0),
	new fecha(0,0),
	new fecha(0,0),
	new fecha(0,0),
	new fecha(0,0),
	new fecha(0,0),
	new fecha(0,0),
	new fecha(0,0),
	new fecha(0,0),
	new fecha(0,0),
	new fecha(0,0),
	new fecha(0,0),
	new fecha(0,0),
    };
    //Numero de dias en cada mes
    private static int monthday[]=
    { 31,28,31,30,31,30,31,31,30,31,30,31 };
    private static int leapmonthday[]=
    { 31,29,31,30,31,30,31,31,30,31,30,31 };
    
    private String dayname[]=
    { "Sunday","Monday","Tuesday","Wednesday","Thursday","Friday","Saturday","Sunday"};
    
    Panel p=new Panel();
    Panel hbox,hbox2,hbox3,hbox4;
    TextField inputfield;
    Label mensaje1,mensaje2,mensaje3;
    Button okboton;
    Label etiq;
    String texto;
    
    
    public void main(String Args[]) {
	if(Args.length>0) {
	    System.out.println(Args[0]);
	    anio=Integer.parseInt(Args[0]);
	    anio=java.lang.Math.abs(anio);
	}
	inicializar();
	Procesar(anio);
    }
 
    public void init() {
	inicializar();  //Inicializa los datos astronmicos
	
	hbox=new Panel();
	hbox.setLayout(new FlowLayout(FlowLayout.LEFT));
	hbox2=new Panel();
	hbox3=new Panel();
	hbox4=new Panel();
	hbox2.setLayout(new FlowLayout(FlowLayout.LEFT));
	hbox3.setLayout(new FlowLayout(FlowLayout.LEFT));
	hbox4.setLayout(new FlowLayout(FlowLayout.LEFT));
	p.setLayout(new GridLayout(4,1));
	
	inputfield=new TextField(8);
	mensaje1=new Label("                                                                                            ");
	mensaje2=new Label("                                                                                         ");   
	mensaje3=new Label("                                                                           ");
	okboton=new Button("Ok");
	etiq=new Label(titulo);
	
	hbox.add(etiq);
	hbox.add(inputfield);
	hbox.add(okboton);
	p.add(hbox);
	hbox2.add(mensaje1);
	hbox3.add(mensaje2);
	hbox4.add(mensaje3);
	p.add(hbox2);
	p.add(hbox3);
	p.add(hbox4);
	add(p);
    }
	
    public void start() {
    }
    
    //Limpia los mensajes
    public void clearmsgs() {
	mensaje1.setText("                                     ");
	mensaje2.setText("                                     ");
	mensaje3.setText("                                     ");
    }
    
    public boolean action(Event evt, Object arg) {
	if(evt.target.equals(okboton)) {
	    texto=inputfield.getText();
	    if(!texto.equals(""))
	       anio=Integer.parseInt(texto); 
	    else {
		clearmsgs();
		mensaje1.setText("Please specify a year");
		return true;
	    }
	    if(anio<0) anio=java.lang.Math.abs(anio);

	    if(anio==0) {
		clearmsgs();
		mensaje1.setText("There was no year 0");
		return true;
	    }
	    
	    Procesar(anio);
	    procesado=true;
	    repaint();
	}
	return true;
    }
    
    
    private static boolean isleap(int anio) {
	//esto parece algo asi como Java ofuscado...
	if(anio <= 1582) {
	    return (anio%4 == 0) ? true : false;
	} else {
	    return ((anio%4==0) ? true : false ) &&
		( ((anio%100==0) ? false : true ) || ((anio%400==0) ? true : false) );
	}
 
    }
    
    //numero de aos bisiestos julianos que no son bisiestos gregorianos desde 1582
    private static int notleapsince1582(int anio) {
	return ( (anio>=1600) ? anio/100-16 : 0 ) - ( (anio>=2000) ? anio/400-4 : 0 );
    }
    
    //numero de aos bisiestos desde el ao 1
    private static int leapsince1(int anio) {
	return anio/4 - notleapsince1582(anio);
    }
    
    //inicializa las variables
    private static int inicializar() {
       	pascal[0].ponfecha(0,0);
	pascal[1].ponfecha(12,4);
	pascal[2].ponfecha(11,4);
	pascal[3].ponfecha(10,4);
	pascal[4].ponfecha(9,4);
	pascal[5].ponfecha(8,4);
	pascal[6].ponfecha(7,4);
	pascal[7].ponfecha(6,4);
	pascal[8].ponfecha(5,4);
	pascal[9].ponfecha(4,4);
	pascal[10].ponfecha(3,4);
	pascal[11].ponfecha(2,4);
	pascal[12].ponfecha(1,4);
	pascal[13].ponfecha(31,3);
	pascal[14].ponfecha(30,3);
	pascal[15].ponfecha(29,3);
	pascal[16].ponfecha(28,3);
	pascal[17].ponfecha(27,3);
	pascal[18].ponfecha(26,3);
	pascal[19].ponfecha(25,3);
        pascal[20].ponfecha(24,3);
	pascal[21].ponfecha(23,3);
	pascal[22].ponfecha(22,3);
	pascal[23].ponfecha(21,3);
	pascal[24].ponfecha(18,4);
	pascal[25].ponfecha(0,0);
	pascal[26].ponfecha(17,4);
	pascal[27].ponfecha(16,4);
	pascal[28].ponfecha(15,4);
	pascal[29].ponfecha(14,4);
	pascal[30].ponfecha(13,4);
	//Si epacta==25, la luna pascual se determina por el numero aureo
	return 1;
    }
    private int Procesar(int anio) {
	int gn; //numero aureo
	int ep; //epacta
	int cent=0; //siglo
	fecha llena; //Luna llena de Pascua
	fecha Pascua; //fecha de Pascua
	int julianday;
	int weekday;
	
	cent=((anio-(anio%100))/100)+1;
	gn=(anio%19)+1;
	ep=(11*(gn-1))%30;
	ep=(ep-(3*cent)/4);
	ep=ep+(8*cent+5)/25;
	ep+=8;
	while(ep<=0) ep+=30;
	while(ep>30) ep-=30;
	
	System.out.println("Ao "+anio+". Bisiesto? "+isleap(anio));
	//System.out.println("El numero aureo es "+gn+". La epacta es "+ep);
	mensaje1.setText("Golden Number is "+gn+". Epacta is "+ep);
	
	//llena=new fecha(0,0);
	llena=pascal[ep];
        if(ep==25) {	    
	    if(gn>11) {
		llena.ponfecha(17,4);
	    }
	    if(gn<=11) {
		llena.ponfecha(18,4);
	    }
	}
	
	//System.out.println(llena);
	//System.out.println("La luna llena pascual es el "+llena.dia+"-"+llena.mes);
	mensaje2.setText("Paschal full moon is "+llena.dia+"-"+llena.mes);
	
	//Ahora hay que calcular el domingo siguiente a la luna llena pascual
	
	julianday=jday(llena.dia,llena.mes,anio);
	weekday=dayofweek(llena.dia,llena.mes,anio);
	julianday+=7-weekday;
	
	Pascua=juliantodate(julianday,anio);
	
	//System.out.println("La pascua es el "+Pascua);
	mensaje3.setText("Easter is "+Pascua.dia+" -"+Pascua.mes);
	return 1;
	 
    }
	 
    //Dia de la semana de una fecha (0=domingo, 1=lunes ... 6=sabado)
    private static int dayofweek(int dia,int mes,int anio) {
	long julianday; //Dia juliano total desde 1 Ene 1
	int weekday=4; //Jueves
	
	julianday=(anio-1)*365+leapsince1(anio-1)+jday(dia,mes,anio);
	
	if(julianday < JULIAN5OCT1582 ) { //Calendario juliano
	    weekday=(int)((julianday-1 +6)%7);
	}
	if(julianday >= JULIAN5OCT1582+9) {
	    weekday=(int)((julianday-1 +6 -10)%7);
	}
	return weekday;
	
    }
    
    //Dia juliano (numero del dia dentro del ao)
    private static int jday(int dia,int mes,int ano) {
	int temp=0,i;
	
	if(isleap(anio)) {
	    for(i=0;i<mes-1;++i)
		temp+=leapmonthday[i];
	    temp+=dia;
	}
	else {
	    for(i=0;i<mes-1;++i)
		temp+=monthday[i];
	    temp+=dia;
	}
	return temp;
    }
    
    static fecha juliantodate(int julian,int anio) {
	int i;
	fecha valor;
	
	valor=new fecha(0,0);
	if(isleap(anio)) {
	    for(i=0;i<12;++i) {
		julian-=leapmonthday[i];
		if(julian<=0) {
		    valor.mes=i+1;
		    valor.dia=julian+leapmonthday[i];
		    return valor;
		}
	    }
	}
	else {    
	    for(i=0;i<12;++i) {
		julian-=monthday[i];
		if(julian<=0) {
		    valor.mes=i+1;
		    valor.dia=julian+monthday[i];
		    return valor;
		}
	    }
	}
	return null;
    }
    
}
